<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { onMounted, ref, inject } from 'vue';
import { useRoute, useRouter } from 'vue-router';
import { storeToRefs } from 'pinia';
import { useI18n } from 'vue-i18n';
import { useMetaStore } from '@/stores/meta';
import { request } from '@/lib/request';
import Freeform from '@/components/freeform/Index.vue';
import Schedule from '@/components/schedule/Index.vue';
import Timeline from '@/components/timeline/Index.vue';
import { adminMenuEnum } from '@/enums/enums';
import QRCodeModal from '@/components/general/QRCodeModal.vue';
import PDFExportModal from '@/components/general/PDFExportModal.vue';
import PasswordResetModal from '@/components/PanePasswordResetModal.vue';
import DeleteModal from '@/components/DeletePaneModal.vue';
import CopyForMeModal from '@/components/CopyForMeModal.vue';
import ShareModal from '@/components/ShareModal.vue';
import AdministrationSideBar from '@/components/general/AdministrationSidebar.vue';

const { t } = useI18n();
const $t = t; 
document.title = $t('login.title');
const route = useRoute()
const router = useRouter();
const metaStore = useMetaStore();
const { hashcode, noPassHash, adminMail, paneType, openMenu } = storeToRefs(metaStore);
const showPane = ref(false);
const boardType = ref(null);
let configuration = inject<any>('configuration');

onMounted(async()=>{
    if(route.params.id){
        hashcode.value = String(route.params.id);
        let response = await request('GET', configuration.apiServer + '/api/pane/'+hashcode.value,undefined,undefined,undefined,true);
        if(response && response.success){
            boardType.value = response.type.toLowerCase();
            paneType.value = response.type.toLowerCase();
            adminMail.value = response.adminMail;
            if(response.noPassHash)
                noPassHash.value = response.noPassHash;
            showPane.value = true;
        }else{
            router.push({name: 'mod-pane', params:{id: route.params.id}});
        }
    }else{
        router.push({name: "home"});
    }
});

</script>
<template>
    <div>
        <div v-if="showPane">
            <Freeform v-if="boardType === 'freeform' "/>
            <Schedule v-else-if="boardType === 'schedule' || boardType === 'stream'" />
            <Timeline v-else-if="boardType === 'timeline'" />
        </div>
        <div v-if="adminMail">
            <QRCodeModal v-if="openMenu === adminMenuEnum.QRCODE" />
            <PasswordResetModal v-if="openMenu === adminMenuEnum.PASSWORDRESET" />
            <DeleteModal v-if="openMenu === adminMenuEnum.DELETE" />
            <PDFExportModal v-if="openMenu === adminMenuEnum.EXPORTPDF"/>
            <CopyForMeModal v-if="openMenu === adminMenuEnum.COPY"/>
            <ShareModal v-if="openMenu === adminMenuEnum.SHARE"/>
            <AdministrationSideBar v-if="openMenu === adminMenuEnum.SETTINGS"/>
        </div>
    </div>
</template>